#include <stdio.h>
#include <string.h>

#include "nanohttp/nanohttp-client.h"

#include "TimbraCFDI.h"

#define MAX_BUFFER_SIZE 1024



char *filetob64(char *file);

int lengBuff(byte_t *b)
{
	int i=0;
	while (b[i++]!=0) {}
	return i-1;
}

static const char cb64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

static const char cd64[] = "|$$$}rstuvwxyz{$$$$$$$>?@ABCDEFGHIJKLMNOPQRSTUVW$$$$$$XYZ[\\]^_`abcdefghijklmnopq";

static void encodeblock( unsigned char *in, unsigned char *out, int len )
{
    out[0] = (unsigned char) cb64[ (int)(in[0] >> 2) ];
    out[1] = (unsigned char) cb64[ (int)(((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4)) ];
    out[2] = (unsigned char) (len > 1 ? cb64[ (int)(((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6)) ] : '=');
    out[3] = (unsigned char) (len > 2 ? cb64[ (int)(in[2] & 0x3f) ] : '=');
}

void base64e(const unsigned char *instr, size_t tam, unsigned char *outstr)
{
  unsigned char in[3], out[4];
  int i, len;
  size_t cont =0;

  while (cont < tam)
  {
    len = 0;
    for (i = 0; i < 3; i++)
    {
      if (cont++ < tam)
      {
		in[i] = (unsigned char)*instr;
        len++;
        instr++;
      }
    }
    if (len)
    {
      encodeblock(in, out, len);
      for (i = 0; i < 4; i++)
        *outstr++ = out[i];
    }
  }
}

char * filetob64(char *file)
{
	FILE *f = fopen(file, "rb");
	char *contenidof;
	char *b64;
	size_t t;
	if (!f)
		return "ERROR";
	fseek(f, 0L, SEEK_END);
	t = ftell(f);
	fseek(f, 0L, SEEK_SET);
	contenidof = malloc(t + 1);
	b64 = malloc(2 * t);
	
	t = fread(contenidof, 1, t, f);

	base64e(contenidof, t, b64);

	close(f);
	
	return b64;
}

char * dameResultado(int argc, char **argv, byte_t * buffer, const char *action)
{
	herror_t status;
	size_t len, lenr;
	httpc_conn_t *conn;
	hresponse_t *result;
	byte_t *respuesta = NULL;
	byte_t buffere[MAX_BUFFER_SIZE];
	char lengbuffer[32];
	
	sprintf(lengbuffer, "%d", lengBuff((byte_t *)buffer));

	if ((status = httpc_init(argc, argv)) != H_OK)
	{
		fprintf(stderr, "Cannot init client (%s)\n", herror_message(status));
		herror_release(status);
		exit(1);
	}
	
	if (!(conn = httpc_new()))
	{
		fprintf(stderr, "Cannot create client connection\n");
		httpc_destroy();
		exit(1);
	}
	
	httpc_set_header(conn, "Content-type", "text/xml; charset=utf-8");
	httpc_add_header(conn, "Content-length", lengbuffer);
	httpc_add_header(conn, "Soapaction", action);
	
	if ((status = httpc_post_begin(conn, argv[1])) != H_OK)
	{
		fprintf(stderr, "Client connection failed (%s)\n", herror_message(status));
		herror_release(status);
		httpc_destroy();
		exit(1);
	}
	
	if ((status = http_output_stream_write(conn->out, buffer, lengBuff(buffer))) != H_OK)
	{
		fprintf(stderr, "Client sending POST data failed (%s)\n", herror_message(status));
		herror_release(status);
		httpc_destroy();
		exit(1);
	}
	
	if ((status = httpc_post_end(conn, &result)) != H_OK)
	{
		fprintf(stderr, "Client POST failed (%s)\n", herror_message(status));
		herror_release(status);
		httpc_destroy();
		exit(1);
	}
	
	lenr = 0;
	
	while (http_input_stream_is_ready(result->in))
	{
		size_t i;
		len = http_input_stream_read(result->in, buffere, MAX_BUFFER_SIZE);
		if (respuesta == NULL)
			respuesta = malloc(len+1);
		else
		{
			char *aux = respuesta;
			respuesta = malloc(lenr+len+1);
			for (i = 0; i<lenr; i++)
				respuesta[i]=aux[i];
			free(aux);
		}
		
		strncpy(respuesta+lenr, buffere, len);
			
		lenr += len;
	}
	
	respuesta[lenr] = 0;
	
	hresponse_free(result);
	httpc_free(conn);
	return respuesta;
}

//Métodos

char * registraEmisor(char *usuario, char *emisor, char *cert, char *key, char *pass, char *url)
{
	int argc = 0;
	char *argv[2];
	char *buffer;
	char *certificado;
	char *privada;
	
	char *formato="<?xml version=\"1.0\" encoding=\"utf-8\"?>"
					"<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">"
					  "<soap:Body>"
					    "<RegistraEmisor xmlns=\"http://localhost/\">"
					      "<usuarioIntegrador>%s</usuarioIntegrador>"
					      "<rfcEmisor>%s</rfcEmisor>"
					      "<base64Cer>%s</base64Cer>"
					      "<base64Key>%s</base64Key>"
					      "<contrasena>%s</contrasena>"
					    "</RegistraEmisor>"
					  "</soap:Body>"
					"</soap:Envelope>";
	
	certificado = filetob64(cert);
	privada = filetob64(key);
	

	argv[0]= "";
	if (!strcmp(url, ""))
		argv[1]= "http://201.175.12.89/servicioIntegracionpruebas/timbrado.asmx?WSDL";
	else
		argv[1] = url;
	
	buffer = malloc(lengBuff((byte_t *)usuario) + lengBuff((byte_t *)emisor) + lengBuff((byte_t *)certificado) + 
					lengBuff((byte_t *)privada) + lengBuff((byte_t *)pass) + lengBuff((byte_t *)formato));

	sprintf(buffer, formato, usuario, emisor, certificado, privada, pass);
	
	return dameResultado(argc, argv, buffer, "http://localhost/RegistraEmisor");
}

char * timbraCFDI(char *integrador, char *ficheroComprobante, char *idComprobante, char *url)
{
	int argc = 0;
	char *argv[2];
	char lengbuffer[32];
	char *buffer;
	char *comprobante;
	
	char *formato="<?xml version=\"1.0\" encoding=\"utf-8\"?>"
					"<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">"
					  "<soap:Body>"
					    "<TimbraCFDI xmlns=\"http://localhost/\">"
					      "<usuarioIntegrador>%s</usuarioIntegrador>"
					      "<xmlComprobanteBase64>%s</xmlComprobanteBase64>"
					      "<idComprobante>%s</idComprobante>"
					    "</TimbraCFDI>"
					  "</soap:Body>"
					"</soap:Envelope>";
	
	comprobante = filetob64(ficheroComprobante);

	argv[0]= "";
	if (!strcmp(url, ""))
		argv[1]= "http://201.175.12.89/servicioIntegracionpruebas/timbrado.asmx?WSDL";
	else
		argv[1] = url;
	
	buffer = malloc(lengBuff((byte_t *)integrador) + lengBuff((byte_t *)comprobante) + 
					lengBuff((byte_t *)idComprobante) + lengBuff((byte_t *)formato));

	sprintf(buffer, formato, integrador, comprobante, idComprobante);

	return dameResultado(argc, argv, buffer, "http://localhost/TimbraCFDI");
}

char * obtieneCFDI(char *integrador, char *emisor, char *uuid, char *url)
{
	int argc = 0;
	char *argv[2];
	char lengbuffer[32];
	char *buffer;
	
	char *formato="<?xml version=\"1.0\" encoding=\"utf-8\"?>"
					"<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">"
					  "<soap:Body>"
					    "<ObtieneCFDI xmlns=\"http://localhost/\">"
					      "<usuarioIntegrador>%s</usuarioIntegrador>"
					      "<rfcEmisor>%s</rfcEmisor>"
					      "<folioUUID>%s</folioUUID>"
					    "</ObtieneCFDI>"
					  "</soap:Body>"
					"</soap:Envelope>";
	
	argv[0]= "";
	if (!strcmp(url, ""))
		argv[1]= "http://201.175.12.89/servicioIntegracionpruebas/timbrado.asmx?WSDL";
	else
		argv[1] = url;
	
	buffer = malloc(lengBuff((byte_t *)integrador) + lengBuff((byte_t *)emisor) + 
					lengBuff((byte_t *)uuid) + lengBuff((byte_t *)formato));

	sprintf(buffer, formato, integrador, emisor, uuid);

	return dameResultado(argc, argv, buffer, "http://localhost/ObtieneCFDI");
}

char * cancelaCFDI(char *integrador, char *emisor, char *uuid, char *url)
{
	int argc = 0;
	char *argv[2];
	char lengbuffer[32];
	char *buffer;
	
	char *formato="<?xml version=\"1.0\" encoding=\"utf-8\"?>"
					"<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">"
					  "<soap:Body>"
					    "<CancelaCFDI xmlns=\"http://localhost/\">"
					      "<usuarioIntegrador>%s</usuarioIntegrador>"
					      "<rfcEmisor>%s</rfcEmisor>"
					      "<folioUUID>%s</folioUUID>"
					    "</CancelaCFDI>"
					  "</soap:Body>"
					"</soap:Envelope>";
	
	argv[0]= "";
	if (!strcmp(url, ""))
		argv[1]= "http://201.175.12.89/servicioIntegracionpruebas/timbrado.asmx?WSDL";
	else
		argv[1] = url;
	
	buffer = malloc(lengBuff((byte_t *)integrador) + lengBuff((byte_t *)emisor) + 
					lengBuff((byte_t *)uuid) + lengBuff((byte_t *)formato));

	sprintf(buffer, formato, integrador, emisor, uuid);

	return dameResultado(argc, argv, buffer, "http://localhost/CancelaCFDI");
}
